## apr-util 1.6.1

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(APR-Util C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

FIND_PACKAGE(OpenSSL)

FIND_PACKAGE(expat)

OPTION(APU_HAVE_CRYPTO      "Crypto support"                            OFF)
OPTION(APU_HAVE_ODBC        "Build ODBC DBD driver"                     ON)
OPTION(APR_HAS_LDAP         "LDAP support"                              ON)
OPTION(INSTALL_PDB          "Install .pdb files (if generated)"         ON)
OPTION(APR_BUILD_TESTAPR    "Build the test suite"                      OFF)
OPTION(TEST_STATIC_LIBS     "Test programs use APR static libraries instead of shared libraries?" OFF)
SET(APR_INCLUDE_DIR         "${CMAKE_INSTALL_PREFIX}/include"           CACHE STRING "Directory with APR include files")
SET(APR_LIBRARIES           "${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib"  CACHE STRING "APR library to link with")

IF(NOT EXISTS "${APR_INCLUDE_DIR}/apr.h")
  MESSAGE(FATAL_ERROR "APR include directory ${APR_INCLUDE_DIR} is not correct.")
ENDIF()
FOREACH(onelib ${APR_LIBRARIES})
  IF(NOT EXISTS ${onelib})
    MESSAGE(FATAL_ERROR "APR library ${onelib} was not found.")
  ENDIF()
ENDFOREACH()

IF(APU_HAVE_CRYPTO)
IF(NOT OPENSSL_FOUND)
  MESSAGE(FATAL_ERROR "OpenSSL is the only supported crypto implementation, and it wasn't found!")
ENDIF()
ENDIF()

# create 1-or-0 representation of feature tests for apu.h

SET(apu_have_crypto_10 0)
SET(apu_have_apr_iconv_10 0) # not yet implemented
SET(apr_has_ldap_10 0)

IF(APU_HAVE_CRYPTO)
  SET(apu_have_crypto_10 1)
ENDIF()

IF(APR_HAS_LDAP)
  SET(apr_has_ldap_10 1)
ENDIF()

IF(NOT EXPAT_FOUND)
  MESSAGE(FATAL_ERROR "Expat is required, and it wasn't found!")
ENDIF()

SET(XMLLIB_INCLUDE_DIR   ${EXPAT_INCLUDE_DIRS})
SET(XMLLIB_LIBRARIES     ${EXPAT_LIBRARIES})

SET(LDAP_LIBRARIES)
IF(APR_HAS_LDAP)
  SET(LDAP_LIBRARIES wldap32)
ENDIF()

CONFIGURE_FILE(include/apu.hwc
              ${PROJECT_BINARY_DIR}/apu.h)
CONFIGURE_FILE(include/apr_ldap.hwc
              ${PROJECT_BINARY_DIR}/apr_ldap.h)
# "COPYONLY" just because anything else isn't implemented ;)
CONFIGURE_FILE(include/private/apu_config.hw
               ${PROJECT_BINARY_DIR}/apu_config.h
               COPYONLY)
CONFIGURE_FILE(include/private/apu_select_dbm.hw
               ${PROJECT_BINARY_DIR}/apu_select_dbm.h
               COPYONLY)
CONFIGURE_FILE(include/apu_want.hw
               ${PROJECT_BINARY_DIR}/apu_want.h
               COPYONLY)

# Generated .h files are stored in PROJECT_BINARY_DIR, not the
# source tree.
#
# BROKEN: not searching PROJECT_BINARY_DIR first, so you have to
#         manually delete apu.h in PROJECT_SOURCE_DIR/include if
#         you've generated apu.h before using a different build

SET(APR_INCLUDE_DIRECTORIES
  ${PROJECT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/private
  ${APR_INCLUDE_DIR}
)

INCLUDE_DIRECTORIES(${APR_INCLUDE_DIRECTORIES} ${XMLLIB_INCLUDE_DIR})

SET(APR_PUBLIC_HEADERS_STATIC
  include/apr_anylock.h
  include/apr_base64.h
  include/apr_buckets.h
  include/apr_crypto.h
  include/apr_date.h
  include/apr_dbd.h
  include/apr_dbm.h
  include/apr_hooks.h
  include/apr_ldap_init.h
  include/apr_ldap_option.h
  include/apr_ldap_rebind.h
  include/apr_ldap_url.h
  include/apr_md4.h
  include/apr_md5.h
  include/apr_memcache.h
  include/apr_optional.h
  include/apr_optional_hooks.h
  include/apr_queue.h
  include/apr_redis.h
  include/apr_reslist.h
  include/apr_rmm.h
  include/apr_sdbm.h
  include/apr_sha1.h
  include/apr_siphash.h
  include/apr_strmatch.h
  include/apr_thread_pool.h
  include/apr_uri.h
  include/apr_uuid.h
  include/apr_xlate.h
  include/apr_xml.h
  include/apu_errno.h
  include/apu_version.h
)

# apu_config.h and apu_select_dbm.h are private
SET(APR_PUBLIC_HEADERS_GENERATED
  ${PROJECT_BINARY_DIR}/apu.h
  ${PROJECT_BINARY_DIR}/apr_ldap.h
  ${PROJECT_BINARY_DIR}/apu_want.h
)

SET(APR_SOURCES
  buckets/apr_brigade.c
  buckets/apr_buckets.c
  buckets/apr_buckets_alloc.c
  buckets/apr_buckets_eos.c
  buckets/apr_buckets_file.c
  buckets/apr_buckets_flush.c
  buckets/apr_buckets_heap.c
  buckets/apr_buckets_mmap.c
  buckets/apr_buckets_pipe.c
  buckets/apr_buckets_pool.c
  buckets/apr_buckets_refcount.c
  buckets/apr_buckets_simple.c
  buckets/apr_buckets_socket.c
  crypto/apr_crypto.c
  crypto/apr_md4.c
  crypto/apr_md5.c
  crypto/apr_passwd.c
  crypto/apr_sha1.c
  crypto/apr_siphash.c
  crypto/crypt_blowfish.c
  crypto/getuuid.c
  crypto/uuid.c
  dbd/apr_dbd.c
  dbm/apr_dbm.c
  dbm/apr_dbm_sdbm.c
  dbm/sdbm/sdbm.c
  dbm/sdbm/sdbm_hash.c
  dbm/sdbm/sdbm_lock.c
  dbm/sdbm/sdbm_pair.c
  encoding/apr_base64.c
  hooks/apr_hooks.c
  memcache/apr_memcache.c
  misc/apr_date.c
  misc/apr_queue.c
  misc/apr_reslist.c
  misc/apr_rmm.c
  misc/apr_thread_pool.c
  misc/apu_dso.c
  misc/apu_version.c
  redis/apr_redis.c
  strmatch/apr_strmatch.c
  uri/apr_uri.c
  xlate/xlate.c
  xml/apr_xml.c
)

IF(APR_HAS_LDAP)
  SET(APR_SOURCES ${APR_SOURCES} ldap/apr_ldap_stub.c ldap/apr_ldap_url.c)
ENDIF()

SET(APR_TEST_SOURCES
  test/abts.c
  test/testbuckets.c
  test/testcrypto.c
  test/testdate.c
  test/testdbd.c
  test/testdbm.c
  test/testldap.c
  test/testmd4.c
  test/testmd5.c
  test/testmemcache.c
  test/testpass.c
  test/testqueue.c
  test/testredis.c
  test/testreslist.c
  test/testrmm.c
  test/testsiphash.c
  test/teststrmatch.c
  test/testuri.c
  test/testutil.c
  test/testuuid.c
  test/testxlate.c
  test/testxml.c
)

SET(install_targets)
SET(install_bin_pdb)
SET(dbd_drivers)

# Note: The WINNT definition on some targets is used only by libaprutil.rc.

# libaprutil-1 is shared, aprutil-1 is static
ADD_LIBRARY(libaprutil-1 SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libaprutil.rc)
SET(install_targets ${install_targets} libaprutil-1)
SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/libaprutil-1.pdb)
TARGET_LINK_LIBRARIES(libaprutil-1 ${APR_LIBRARIES} ${XMLLIB_LIBRARIES})
SET_TARGET_PROPERTIES(libaprutil-1 PROPERTIES COMPILE_DEFINITIONS "APU_DECLARE_EXPORT;APR_DECLARE_EXPORT;XML_STATIC;WINNT")

ADD_LIBRARY(aprutil-1 STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} aprutil-1)
TARGET_LINK_LIBRARIES(aprutil-1 ${APR_LIBRARIES} ${XMLLIB_LIBRARIES})
SET_TARGET_PROPERTIES(aprutil-1 PROPERTIES COMPILE_DEFINITIONS "APU_DECLARE_STATIC;APR_DECLARE_STATIC;APU_DSO_MODULE_BUILD;XML_STATIC")

IF(APU_HAVE_CRYPTO)
  IF(NOT OPENSSL_FOUND)
    MESSAGE(FATAL_ERROR "Only OpenSSL-based crypto is currently implemented in the cmake build")
  ENDIF()
  ADD_LIBRARY(apr_crypto_openssl-1 SHARED crypto/apr_crypto_openssl.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_crypto_openssl-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_crypto_openssl-1.pdb)
  SET_TARGET_PROPERTIES(apr_crypto_openssl-1 PROPERTIES INCLUDE_DIRECTORIES "${APR_INCLUDE_DIRECTORIES};${OPENSSL_INCLUDE_DIR}")
  SET_TARGET_PROPERTIES(apr_crypto_openssl-1 PROPERTIES COMPILE_DEFINITIONS "WINNT")
  SET_TARGET_PROPERTIES(apr_crypto_openssl-1 PROPERTIES COMPILE_FLAGS "-DAPR_DECLARE_EXPORT=1 -DAPU_DECLARE_EXPORT=1 -DDLL_NAME=apr_crypto_openssl")
  TARGET_LINK_LIBRARIES(apr_crypto_openssl-1 libaprutil-1 ${APR_LIBRARIES} ${OPENSSL_LIBRARIES})
ENDIF()

IF(APU_HAVE_ODBC)
  ADD_LIBRARY(apr_dbd_odbc-1 SHARED dbd/apr_dbd_odbc.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_dbd_odbc-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_dbd_odbc-1.pdb)
  SET(dbd_drivers ${dbd_drivers} odbc)
  TARGET_LINK_LIBRARIES(apr_dbd_odbc-1 libaprutil-1 ${APR_LIBRARIES} odbc32 odbccp32)
  SET_PROPERTY(TARGET apr_dbd_odbc-1 APPEND PROPERTY LINK_FLAGS /export:apr_dbd_odbc_driver)
  SET_TARGET_PROPERTIES(apr_dbd_odbc-1 PROPERTIES COMPILE_DEFINITIONS "APU_HAVE_ODBC;HAVE_SQL_H;APU_DECLARE_EXPORT;APR_DECLARE_EXPORT;APU_DSO_MODULE_BUILD;WINNT")
  SET_TARGET_PROPERTIES(apr_dbd_odbc-1 PROPERTIES COMPILE_FLAGS "-DAPR_DECLARE_EXPORT=1 -DAPU_DECLARE_EXPORT=1 -DDLL_NAME=apr_dbd_odbc")
ENDIF()

IF(APR_HAS_LDAP)
  ADD_LIBRARY(apr_ldap-1 SHARED ldap/apr_ldap_init.c ldap/apr_ldap_option.c 
              ldap/apr_ldap_rebind.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_ldap-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_ldap-1.pdb)
  TARGET_LINK_LIBRARIES(apr_ldap-1 libaprutil-1 ${APR_LIBRARIES} ${LDAP_LIBRARIES})
  SET_TARGET_PROPERTIES(apr_ldap-1 PROPERTIES COMPILE_DEFINITIONS "WINNT")
  SET_TARGET_PROPERTIES(apr_ldap-1 PROPERTIES COMPILE_FLAGS "-DAPR_DECLARE_EXPORT=1 -DAPU_DECLARE_EXPORT=1 -DDLL_NAME=apr_ldap")
  SET(apr_ldap_libraries apr_ldap-1)
ELSE()
  SET(apr_ldap_libraries)
ENDIF()

IF(APR_BUILD_TESTAPR)
  ENABLE_TESTING()
  # Create a "check" target that displays test program output to the console.
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

  # copy data files to build directory so that we can run programs from there
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E make_directory 
                  ${PROJECT_BINARY_DIR}/data)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different 
                  ${PROJECT_SOURCE_DIR}/test/data/billion-laughs.xml
                  ${PROJECT_BINARY_DIR}/data/billion-laughs.xml)

  IF(TEST_STATIC_LIBS)
    SET(whichapr    aprutil-1)
    SET(apiflag     "-DAPR_DECLARE_STATIC -DAPU_DECLARE_STATIC")
  ELSE()
    SET(whichapr    libaprutil-1)
    SET(apiflag)
  ENDIF()

  ADD_EXECUTABLE(testall ${APR_TEST_SOURCES})
  TARGET_LINK_LIBRARIES(testall ${whichapr} ${apr_ldap_libraries} ${XMLLIB_LIBRARIES} ${LDAP_LIBRARIES})
  IF(apiflag)
    SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()
  ADD_TEST(NAME testall COMMAND testall)

  ADD_EXECUTABLE(dbd test/dbd.c)
  TARGET_LINK_LIBRARIES(dbd ${whichapr})
  IF(apiflag)
    SET_TARGET_PROPERTIES(dbd PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()

  # dbd is run multiple times with different parameters.
  FOREACH(somedbd ${dbd_drivers})
    ADD_TEST(NAME dbd-${somedbd} COMMAND dbd ${somedbd})
  ENDFOREACH()

ENDIF (APR_BUILD_TESTAPR)

# Installation

INSTALL(TARGETS ${install_targets}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )

IF(INSTALL_PDB)
  INSTALL(FILES ${install_bin_pdb}
          DESTINATION bin
          CONFIGURATIONS RelWithDebInfo Debug)
ENDIF()

INSTALL(FILES ${APR_PUBLIC_HEADERS_STATIC} ${APR_PUBLIC_HEADERS_GENERATED} DESTINATION include)

STRING(TOUPPER "${CMAKE_BUILD_TYPE}" buildtype)
MESSAGE(STATUS "")
MESSAGE(STATUS "")
MESSAGE(STATUS "APR-Util configuration summary:")
MESSAGE(STATUS "")
MESSAGE(STATUS "  Build type ...................... : ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "  Install .pdb (if available)...... : ${INSTALL_PDB}")
MESSAGE(STATUS "  Install prefix .................. : ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "  C compiler ...................... : ${CMAKE_C_COMPILER}")
MESSAGE(STATUS "  APR include directory ........... : ${APR_INCLUDE_DIR}")
MESSAGE(STATUS "  APR libraries ................... : ${APR_LIBRARIES}")
MESSAGE(STATUS "  DBD ODBC driver ................. : ${APU_HAVE_ODBC}")
MESSAGE(STATUS "  APU_HAVE_CRYPTO ................. : ${APU_HAVE_CRYPTO}")

=== debian/changelog ===
apr-util (1.6.1-5ubuntu4) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 10:40:50 +0100

apr-util (1.6.1-5ubuntu3) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 03 Dec 2021 14:16:13 +0000

apr-util (1.6.1-5ubuntu2) impish; urgency=medium

  * No-change rebuild due to OpenLDAP soname bump.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 21 Jun 2021 17:43:56 -0400

apr-util (1.6.1-5ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/p/mysql8_my_bool.patch: Reintroduce my_bool to fix build with
      MySQL 8. (LP: #1863026)
    - d/p/mysql8-my_init.patch: don't call my_init() since it's not
      exported anymore since MySQL 8.0.2 (LP: #1859773)

 -- Tiago Stürmer Daitx <tiago.daitx@ubuntu.com>  Mon, 09 Nov 2020 20:30:18 +0000

apr-util (1.6.1-5) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Remove debug package libaprutil1-dbg.
  * Trim trailing whitespace.

  [ Xavier Guimard ]
  * Update signing-key.asc
  * Declare compliance with policy 4.2.1
  * Remove dependency version to libapr1-dev

  [ Stefan Fritsch ]
  * Build-depend on apr >> 1.7.0-1, which switched to python3.
    Remove the python build-dep in apr-util as libapr1-dev now has a
    fixed dependency on python3. Closes: #936129, #969064

 -- Stefan Fritsch <sf@debian.org>  Sat, 29 Aug 2020 11:51:07 +0200

apr-util (1.6.1-4ubuntu2) focal; urgency=medium

  * d/p/mysql8-my_init.patch: don't call my_init() since it's not
    exported anymore since MySQL 8.0.2 (LP: #1859773)

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 04 Mar 2020 16:51:27 -0300

apr-util (1.6.1-4ubuntu1) focal; urgency=medium

  * Adjust Build-Depends to unambiguously require Python 2.
  * d/p/mysql8_my_bool.patch: Reintroduce my_bool to fix build with MySQL 8.
    (LP: #1863026)

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 18 Feb 2020 14:53:49 +0000

apr-util (1.6.1-4build1) eoan; urgency=medium

  * No change rebuild for libmysqlclient21.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 12 Aug 2019 01:59:30 +0000

apr-util (1.6.1-4) unstable; urgency=medium

  * Fix libaprutil1-dbd-mysql with mariadb 10.3. Closes: #926400

 -- Stefan Fritsch <sf@debian.org>  Sun, 21 Apr 2019 09:39:02 +0200

apr-util (1.6.1-3) unstable; urgency=medium

  [ Stefan Fritsch ]
  * Migrate from alioth to salsa

  [ Matthias Klose ]
  * Drop build dependency on libpcre3-dev. Closes: #909077. LP: #1792544.

 -- Stefan Fritsch <sf@debian.org>  Tue, 18 Sep 2018 21:14:24 +0200

apr-util (1.6.1-2) unstable; urgency=medium

  * Avoid empty build target, fixes FTBFS. Thanks to Niels Thykier for the
    patch. Closes: #890108
  * Fix handling of gdbm_errno in gdbm driver. Closes: #889170
  * Bump debhelper compat level to 11 and drop deprecated autotools-dev
    sequence. Thanks to Niels Thykier for the patch.
  * Bump Standards-Version (no changes)
  * Fix mysql/mariadb header detection, broken since 1.5.3-3.
  * Include NOTICE file in packages, as required by license.

 -- Stefan Fritsch <sf@debian.org>  Sun, 25 Feb 2018 12:40:36 +0100

apr-util (1.6.1-1) unstable; urgency=medium

  * New upstream release
    - Fixes CVE-2017-12618: Out-of-bounds access in corrupted SDBM database.
      Closes: #879996

 -- Stefan Fritsch <sf@debian.org>  Mon, 06 Nov 2017 19:48:34 +0100

=== debian/control ===
Source: apr-util
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>> 11~),
               autoconf,
               mawk,
               libldap2-dev,
               libexpat1-dev,
               libdb-dev,
               libgdbm-dev,
               libapr1-dev (>> 1.7.0-0~),
               libsqlite3-dev,
               libpq-dev,
               default-libmysqlclient-dev,
               unixodbc-dev,
               doxygen,
               libssl-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/apache-team/apr-util
Vcs-Git: https://salsa.debian.org/apache-team/apr-util.git
Homepage: http://apr.apache.org/

Package: libaprutil1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libapr1 (<< 1.4.8-2~)
Description: Apache Portable Runtime Utility Library
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.

Package: libaprutil1-ldap
Architecture: any
Multi-Arch: same
Depends: libaprutil1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Apache Portable Runtime Utility Library - LDAP Driver
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the LDAP driver.

Package: libaprutil1-dbd-mysql
Architecture: any
Multi-Arch: same
Depends: libaprutil1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Apache Portable Runtime Utility Library - MySQL Driver
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the MySQL / mariadb database driver.

Package: libaprutil1-dbd-sqlite3
Architecture: any
Multi-Arch: same
Depends: libaprutil1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Apache Portable Runtime Utility Library - SQLite3 Driver
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the SQLite3 database driver.

Package: libaprutil1-dbd-odbc
Architecture: any
Multi-Arch: same
Depends: libaprutil1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Apache Portable Runtime Utility Library - ODBC Driver
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the ODBC database driver.

Package: libaprutil1-dbd-pgsql
Architecture: any
Multi-Arch: same
Depends: libaprutil1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Apache Portable Runtime Utility Library - PostgreSQL Driver
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the PostgreSQL database driver.

Package: libaprutil1-dev
Architecture: any
Section: libdevel
Depends: libaprutil1 (= ${binary:Version}),
         libldap2-dev,
         libexpat1-dev,
         libapr1-dev,
         ${misc:Depends}
Description: Apache Portable Runtime Utility Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains development headers for APR util.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# for ppc64 on Ubuntu
export DEB_GCC_NO_O3=1

SHELL    := /bin/bash
BUILDDIR := debian/build

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# configure takes ages to test for all db versions. Provide the installed
# version to speed things up.
DB_VERSION = $(shell dpkg-query -W -f '$${Version}' libdb-dev | \
	       perl -pe 's/^(?:[^:]*:)?(\d+)[.](\d+)[.].*/$$1$$2/')

# The 'build' target needs special handling because there there is a directory
# named 'build'.
.PHONY: build
# The build target must not be empty.  Sadly because of how make
# works, we have do duplicate the target in this case.
build:
	dh $@ -B$(BUILDDIR)

%:
	dh $@ -B$(BUILDDIR)

#
# configure
#
CONFFLAGS := LTFLAGS=--no-silent \
	     --host=$(DEB_HOST_GNU_TYPE) \
	     --build=$(DEB_BUILD_GNU_TYPE) \
	     --with-apr=/usr/bin/apr-1-config \
	     --enable-layout=Debian \
	     --includedir=/usr/include/apr-1.0 \
	     --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	     --with-ldap=yes \
	     --with-dbm=db$(DB_VERSION) \
	     --with-sqlite3 \
	     --with-pgsql=/usr \
	     --with-gdbm \
	     --without-sqlite2 \
	     --with-berkeley-db \
	     --with-mysql=/usr \
	     --with-odbc=/usr \
	     --with-openssl=/usr \
	     --with-crypto \
	     ac_cv_prog_AWK=mawk

# files that are modified by buildconf and need to be restored during clean
SAVE_FILES := configure build/apr_common.m4

ifeq ($(DEB_HOST_ARCH),i386)
	CONFFLAGS += apr_lock_method=USE_PROC_PTHREAD_SERIALIZE
else
	CONFFLAGS += ac_cv_func_pthread_mutexattr_setpshared=no \
		     ac_cv_func_sem_open=no
endif

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/docs
	for f in $(SAVE_FILES) ; do [ -e $$f.dr-orig ] || cp -p $$f $$f.dr-orig ; done
	./buildconf --with-apr=$(shell apr-1-config --srcdir)
	cd $(BUILDDIR) && $(CURDIR)/configure $(CONFFLAGS)

#
# build
#

# get cflags from apr-config but remove -O2
export DEB_CFLAGS_MAINT_PREPEND := $(shell apr-1-config --cflags |perl -p -e 's!-O.( |$$)!!')
export DEB_LDFLAGS_MAINT_PREPEND := $(shell apr-1-config --ldflags)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEARGS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_build:
	dh_auto_build --parallel -B$(BUILDDIR)
	$(MAKE) $(MAKEARGS) -C $(BUILDDIR) dox

#
# test
#

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(MAKE) -C $(BUILDDIR)/test $(MAKEARGS) all
	$(MAKE) -C $(BUILDDIR)/test -j1 check

else
override_dh_auto_test:

endif

#
# install
#
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libaprutil-1.la

override_dh_strip:
	dh_strip --dbgsym-migration='libaprutil1-dbg (<= 1.6.1-3)'

# The -X option causes the internal-use-only driver libs to be ignored
override_dh_makeshlibs:
	dh_makeshlibs -Xapr-util-1 -- -Idebian/symbols.$(DEB_HOST_ARCH_OS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
	for f in $(SAVE_FILES) ; do [ ! -e $$f.dr-orig ] || mv $$f.dr-orig $$f ; done

## apr-util 1.6.3

=== debian/changelog ===
apr-util (1.6.3-4) unstable; urgency=medium

  * Update watch file version
  * Update upstream signing key
  * Add libcrypt-dev to build-deps. Closes: #1107015
  * Bump standards-version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sat, 08 Nov 2025 09:30:33 +0100

apr-util (1.6.3-3) unstable; urgency=medium

  * Fix db 5.3 detection with gcc 14. Closes: #1074812

 -- Stefan Fritsch <sf@debian.org>  Sun, 04 Aug 2024 12:02:26 +0200

apr-util (1.6.3-2) unstable; urgency=medium

  * Incorporate NMU. Thanks to all the 64-bit time_t transition
    people.
  * Bump libapr1-dev Build-Dep to 1.7.2-3.2. Hopefully
    closes: #1066821
  * Add more 64-bit time_t patches from Simon McVittie. Thanks.
    Closes: #1067035

 -- Stefan Fritsch <sf@debian.org>  Mon, 18 Mar 2024 20:21:56 +0100

apr-util (1.6.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061893

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:16:25 +0000

apr-util (1.6.3-1) unstable; urgency=medium

  [ Stefan Fritsch ]
  * Incorporate NMUs. Closes: #1028435
  * New upstream version:
    - CVE-2022-25147: Fix Integer Overflow or Wraparound vulnerability
      in apr_base64
  * Bump libapr1-dev Build-Dep to 1.7.2-1

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set debhelper-compat version in Build-Depends.
  * Drop unnecessary dh arguments: --parallel
  * Rely on pre-initialized dpkg-architecture variables.
  * Remove constraints unnecessary since buster (oldstable):
    + libaprutil1: Drop conflict with removed package libapr1 (<< 1.4.8-2~) in
      Breaks.

  [ Jelmer Vernooĳ ]
  * Set Repository and Repository-Browse fields in
    debian/upstream/metadata.
  * Drop transition for old debug package migration.
  * Update standards version to 4.6.1, no changes needed.


 -- Stefan Fritsch <sf@debian.org>  Fri, 03 Feb 2023 21:15:18 +0100

apr-util (1.6.1-5.2) unstable; urgency=medium

  * Non-maintainer upload by the Reproducible Builds team.
  * debian/rules: Remove the build path from apt-1-config, using exactly the
    patch from Vagrant Cascadian in #1006865.

 -- Holger Levsen <holger@debian.org>  Thu, 12 Jan 2023 20:28:37 +0100

apr-util (1.6.1-5.1) unstable; urgency=medium

  * Non-maintainer upload by the Reproducible Builds team.
  * debian/rules: Remove the build path from apt-1-config, based on a patch by
    Vagrant Cascadian. Closes: #1006865.

 -- Holger Levsen <holger@debian.org>  Thu, 29 Dec 2022 19:37:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,35 +1,37 @@
 Source: apr-util
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
+Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>> 11~),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 11),
                autoconf,
                mawk,
                libldap2-dev,
                libexpat1-dev,
                libdb-dev,
+               libcrypt-dev,
                libgdbm-dev,
-               libapr1-dev (>> 1.7.0-0~),
+               libapr1-dev (>> 1.7.2-3.2~),
                libsqlite3-dev,
                libpq-dev,
                default-libmysqlclient-dev,
                unixodbc-dev,
                doxygen,
                libssl-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/apache-team/apr-util
 Vcs-Git: https://salsa.debian.org/apache-team/apr-util.git
-Homepage: http://apr.apache.org/
+Homepage: https://apr.apache.org/
 
-Package: libaprutil1
+Package: libaprutil1t64
+Provides: ${t64:Provides}
+Replaces: libaprutil1
+Breaks: libaprutil1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Breaks: libapr1 (<< 1.4.8-2~)
 Description: Apache Portable Runtime Utility Library
  APR is Apache's Portable Runtime Library, designed to be a support library
  that provides a predictable and consistent interface to underlying
@@ -41,7 +43,7 @@
 Package: libaprutil1-ldap
 Architecture: any
 Multi-Arch: same
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -58,7 +60,7 @@
 Package: libaprutil1-dbd-mysql
 Architecture: any
 Multi-Arch: same
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -75,7 +77,7 @@
 Package: libaprutil1-dbd-sqlite3
 Architecture: any
 Multi-Arch: same
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -92,7 +94,7 @@
 Package: libaprutil1-dbd-odbc
 Architecture: any
 Multi-Arch: same
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -109,7 +111,7 @@
 Package: libaprutil1-dbd-pgsql
 Architecture: any
 Multi-Arch: same
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -126,7 +128,7 @@
 Package: libaprutil1-dev
 Architecture: any
 Section: libdevel
-Depends: libaprutil1 (= ${binary:Version}),
+Depends: libaprutil1t64 (= ${binary:Version}),
          libldap2-dev,
          libexpat1-dev,
          libapr1-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,7 @@
 SHELL    := /bin/bash
 BUILDDIR := debian/build
 
-DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
-DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+include /usr/share/dpkg/architecture.mk
 
 # configure takes ages to test for all db versions. Provide the installed
 # version to speed things up.
@@ -82,7 +78,7 @@
 endif
 
 override_dh_auto_build:
-	dh_auto_build --parallel -B$(BUILDDIR)
+	dh_auto_build -B$(BUILDDIR)
 	$(MAKE) $(MAKEARGS) -C $(BUILDDIR) dox
 
 #
@@ -105,9 +101,8 @@
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
 	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libaprutil-1.la
-
-override_dh_strip:
-	dh_strip --dbgsym-migration='libaprutil1-dbg (<= 1.6.1-3)'
+	# Remove the buildpath: https://reproducible-builds.org/docs/build-path/
+	perl -p -i -e "s,$(CURDIR),BUILDPATH," debian/tmp/usr/bin/apu-1-config
 
 # The -X option causes the internal-use-only driver libs to be ignored
 override_dh_makeshlibs:

=== debian/watch ===
Version: 5

Source: http://www.apache.org/dist/apr/
Matching-Pattern: apr-util-(1\..*)\.tar\.gz
Pgpsigurlmangle: s/$/.asc/
